#pragma once
#define WIN32_LEAN_AND_MEAN
#include <Windows.h>
 
 
 
#include <stdexcept>
 
using namespace std;
 
 
class CRun
{
public:
	CRun(){}
	~CRun(){}
	void fnRun()
	{
		puts("fnRun --------------");
		Sleep(500);
	}
};


class CPThread
{
public:
	CPThread(){}
	~CPThread(){}
 
	virtual DWORD Run(void) = 0;
};
 
 
class Thread : public CPThread
{
protected:
	HANDLE Handle;
	DWORD ID;
 
private:
	Thread(const Thread& bt);
	Thread& operator = (const Thread& bt) {};
	static DWORD WINAPI StaticThreadStart(LPVOID lpParam);
 
protected:
	virtual DWORD Run(void)
	{
		while(1)
		{
			m_cr.fnRun();
		}
	}
 
public:
	Thread();
	virtual ~Thread();
	bool Start();
	void Stop();
 
	inline HANDLE GetThreadHandle();
	inline DWORD GetThreadID();
	inline bool IsRunning();
	inline void Join();
	inline BOOL Yeild();
	inline void Sleep(DWORD dsMilliiseconds);
	inline DWORD Suspend();
	inline DWORD Resume();
	
	CRun m_cr;
	void fnSetRun(CRun cr)
	{
		m_cr = cr;
	}
};
 
 
 
 
DWORD WINAPI Thread::StaticThreadStart(LPVOID lpParam)
{
	puts("StaticThreadStart\n");
	Thread* pThread = (Thread*)lpParam;
	return pThread->Run();
}
 
Thread::Thread() : Handle(NULL), ID(0)
{
 
}
 
Thread::~Thread()
{
	if (Handle) CloseHandle(Handle);
}
 
bool Thread::Start()
{
	if (Handle)
	{
		if (WaitForSingleObject(Handle, 0) == WAIT_TIMEOUT)		// Thread Still Running
		{
			return false;
		}
		CloseHandle(Handle);
	}
	Handle = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)Thread::StaticThreadStart, this, 0, &ID);

	char buf[1024];
	sprintf(buf, "Thread Handle : %d\n", Handle);
	puts(buf);

	if (Handle != NULL)
	{
		return true;
	}
	return false;
}
 
void Thread::Stop()
{
	if (this->IsRunning()) {
		::TerminateThread(Handle, -1);
	}
	if (Handle) {
		CloseHandle(Handle);
		Handle = NULL;
	}
}
 
inline HANDLE Thread::GetThreadHandle() {
	return Handle;
}
 
inline DWORD Thread::GetThreadID()
{
	return ID;
}
 
inline bool Thread::IsRunning()
{
	if (Handle) {
		DWORD dwExitCode = 0;
		::GetExitCodeThread(Handle, &dwExitCode);
		if (dwExitCode == STILL_ACTIVE) return true;
	}
	return false;
}
 
inline void Thread::Join()
{
	::WaitForSingleObject(Handle, INFINITE);
}
 
inline BOOL Thread::Yeild()
{
	return ::SwitchToThread();
}
 
inline void Thread::Sleep(DWORD dsMilliiseconds)
{
	::Sleep(dsMilliiseconds);
}
 
inline DWORD Thread::Suspend()
{
	return ::SuspendThread(Handle);
}
 
inline DWORD Thread::Resume()
{
	return ::ResumeThread(Handle);
}
 
 
int main ( int argc, char ** argv )
{
	Thread * ptd = NULL;
	ptd = new Thread();
	
	CRun cr;
	ptd->fnSetRun(cr);

	ptd->Start();
	
	HANDLE Handle = ptd->GetThreadHandle();
	
	char buf[1024];
	sprintf(buf, "[Main] Thread Handle : %d\n", Handle);
	puts(buf);

	puts("[Main] WaitForSingleObject(Handle, INFINITE)");
	WaitForSingleObject(Handle, INFINITE);

	ptd->Stop();
	delete ptd;
 
	puts("exit");
	return 0;
}
 
 
 
 
 
